/*
    Aliments permet une représentation graphique de l'équilibre GPL d'une ration alimentaire.
    Copyright (C) 1994 (version Dos) 2009-2021 Vial Jean-Luc Annecy
    Contact email: vial.frjl@free.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BILANREPAS_H_INCLUDED
#define BILANREPAS_H_INCLUDED

#include <wx/wx.h>
#include "ProjetdeBase.h"

class BilanRepas: public wxFrame
{

public:
    bool item_menu_change,liste_modifiee,est_repertoire;;
// Le conteneur
    TTableau_aliments* conteneur_aliments_Bilan;
// Labels
    static const long idTitres;
    wxStaticText* LabelTitres;
    static const long idLMasse;
    wxStaticText* LabelLMasse;
    static const long idLPourcent;
    wxStaticText* LabelLPourcent;
    static const long idTotal;
    wxStaticText* LabelTotal;
    static const long idPourcentages;
    wxStaticText* LabelPourcentages;
    static const long idPourcentde;
    wxStaticText* LabelPourcentde;

    void Affiche();
// Le constructeur
    BilanRepas(wxWindow* parent,wxWindowID idfenbilanrepas);
// Le destructeur
    ~BilanRepas();

private:
    bool taille_modifiee;

// Boutons
    static const long idBoutPrint;
    wxButton* BoutPrint;

// Combobox Nom des groupes
    static const long idNomGroupes;
    wxComboBox* NomGroupes;
    void OnNomGroupes(wxCommandEvent& event);
    int valindex;
        // Boite texte affichage liste aliments
    static const long idListeAliments;
    wxTextCtrl* ListeAliments;

    void Affiche_proportions();

    void OnPaint(wxPaintEvent& event);
    void OnBoutPrint(wxCommandEvent& event);
    void OnQuit(wxCloseEvent& event);
    void OnSize(wxSizeEvent& event);
    wxPrintData *g_printData;
    DECLARE_EVENT_TABLE()
};

#endif // BILANREPAS_H_INCLUDED
